# run precommit + pytest

precommits:
  stage: test
  tags:
    - cit
  image: containers.ligo.org/lscsoft/bilby_pipe/v3-bilby_pipe-python39
  script:
    - source activate python39
    - mkdir -p .pip39
    - pip install --upgrade pip
    - pip --cache-dir=.pip39 install --upgrade bilby
    - pip --cache-dir=.pip39 install .
    - pip --cache-dir=.pip39 install pre-commit
    # Run precommits (black, flake8, spellcheck, isort, no merge conflicts, etc)
    - pre-commit run --all-files --verbose --show-diff-on-failure


pytest:
  stage: test
  tags:
    - cit
  image: containers.ligo.org/lscsoft/bilby_pipe/v3-bilby_pipe-python39
  script:
    - source activate python39
    - mkdir -p .pip39
    - pip --cache-dir=.pip39 install .[test]
    # Run tests and collect coverage data
    - coverage run --rcfile=setup.cfg -m pytest
    - mpirun -n 4 coverage run --rcfile=setup.cfg -m pytest --with-mpi -s
    - coverage combine
    - coverage html
    - coverage-badge -o coverage_badge.svg -f
    - coverage report

  artifacts:
    paths:
      - htmlcov/
      - coverage_badge.svg
